
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// ! DO NOT EDIT unless you know exactly what you are doing ! //
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

//////////////////////////////// NECESSARY SETUP

//////// generate random election results
float[] genPerc( String names[] ) {
  //////// variables
  int sum = 0;
  int[] votes = new int[ names.length ];
  float[] percs = new float[ names.length ];
  //////// casting the single votes
  for( int n=0; n<names.length; n++ ) {
    int vote = int( random(pow(10,4)) * pow(10,random(1)) );
    sum += vote;
    votes[n] = vote;
  }
  //////// calculating percentages
  for( int n=0; n<names.length; n++ ) {
    float perc = votes[n] / float(sum);
    perc = round(perc*10000) / 100.0;
    percs[n] = perc;
    if( n==0 ) print( "\n[" + n + "] \"" + names[n] + "\" gathered " + percs[n] + "%" );
    else if( n==names.length-1) println( " and [" + n + "] \"" + names[n] + "\" " + percs[n] + "%.");
    else print( ", [" + n + "] \"" + names[n] + "\" " + percs[n] + "%");
  }
  //////// return data
  return percs;
}

//////////////////////////////// USEFUL FUNCTIONS

//////// calculate positioning according to outcome
int[] calcPos( float percs[] ) {
  int[] posis = new int[ percs.length ];
  FloatDict id_percs = new FloatDict();
  for( int n=0; n<percs.length; n++ ) id_percs.set( str(n), percs[n] );
  id_percs.sortValuesReverse();
  IntDict pos_ids = new IntDict();
  for( int n=0; n<percs.length; n++ ) pos_ids.set( str(n), int(id_percs.keyArray()[n]) );
  pos_ids.sortValues();
  print( "Therefore" );
  for( int n=0; n<percs.length; n++ ) {
    posis[n] = int(pos_ids.keyArray()[n]);
    if( n==posis.length-1 ) print( " and " );
    else print( ", " );
    print( "[" + n + "] is #" + (posis[n]+1) );
  }
  println( "." );
  return posis;
}

//////// calculate set of voting entities according to outcome
int[] calcNum( float percs[], int aim_num ) {
  int[] numbs = new int[percs.length];
  print( "Breaking it down to ~" + aim_num + " votes makes clusters of " );
  for( int n=0; n<percs.length; n++ ) {
    int num = round(percs[n]/100*aim_num);
    numbs[n] = num;
    print( num + ", " );
  }
  println( "for the " + numbs.length + " options." );
  return numbs;
}

//////// calculate set of voting entities according to outcome
int[] calcVot( float percs[], int aim_num ) {
  int[] entis = new int[0];
  print( "A corresponding group assembles" );
  for( int n=0; n<percs.length; n++ ) {
    int num = round(percs[n]/100*aim_num);
    for( int o=0; o<num; o++ ) {
      entis = append( entis, n );
    }
    print( " " + num + " entities for [" + n + "]," );
  }
  println( " making it " + entis.length + " votes overall." );
  return entis;
}

//////// draw simple demo output
void simpleDemo( String names[], float[] percs, int[] posis ) {
  //////// depiction
  background( 255 );
  textAlign( LEFT, BOTTOM );
  textSize( height/24 );
  strokeWeight( height/128 );
  stroke( 255 );
  float wid = float(width) / names.length;
  for( int n=0; n<names.length; n++ ) {
    float xpos = wid*posis[n];
    float ypos = height;
    float hei = height*percs[n]/100;
    fill( random(255), random(255), random(255) );
    rect( xpos, ypos, wid, -hei );
    text( " "+(posis[n]+1)+".\n "+names[n]+" ["+n+"]\n "+percs[n]+"%", xpos, ypos-hei );
  }
}

//////// save image
void savePng() {
  //////// naming
  println( "    #### starting to export png image ..." );
  String png_name = "pngs/" + getClass().getSimpleName() + "_" + str(year()).substring(2) + nf(month(), 2) + nf(day(), 2) + "_" + nf(hour(), 2) + nf(minute(), 2) + nf(second(), 2);
  //////// saving
  save( png_name  + ".png" );
  println( png_name + ".png" + " saved!\n" );
}
